#!/usr/bin/env python

from micropython.common import ObjectSet

o1 = ObjectSet()
o1.add("a")
o1.add("b")
o1.add("c")
print "o1 =", o1

o2 = ObjectSet()
o2.add("b")
o2["c"] = ["x"]
o2.add("d")
o2["d"] += ["p", "q"]
print "o2 =", o2

assert o1 != o2
print "o1 == o2", o1 == o2
print "o1 != o2", o1 != o2

o12 = o1.merge(o2)
print "o1 =", o1
print "o2 =", o2
print "o12 =", o12

o12_keys = o12.keys()
o12_keys.sort()
assert o12_keys == ["a", "b", "c", "d"]
print "o12_keys =", o12_keys

o1_copy = ObjectSet(o1)
assert o1 == o1_copy
print "o1 =", o1
print "o1_copy =", o1_copy
print "o1 == o1_copy", o1 == o1_copy

o1_copy.update(o2)
assert o1 != o1_copy
assert o12 == o1_copy
print "o1_copy =", o1_copy
print "o1 != o1_copy", o1 != o1_copy
print "o12 == o1_copy", o12 == o1_copy

o3 = ObjectSet()
o3.add("c")
o3["c"].append("y")
print "o3 =", o3

# vim: tabstop=4 expandtab shiftwidth=4
